// stdint.h

#ifndef STDINT_H
    #define STDINT_H
    
    typedef char                int8_t;
    typedef int                 int16_t;
    typedef long                int32_t;
    typedef char                int_fast8_t;
    typedef int                 int_fast16_t;
    typedef long                int_fast32_t;
    typedef char                int_least8_t;
    typedef int                 int_least16_t;
    typedef long                int_least32_t;
    typedef int32_t             intmax_t;
    
    typedef unsigned char       uint8_t;
    typedef unsigned int        uint16_t;
    typedef unsigned long       uint32_t;
    typedef unsigned char       uint_fast8_t;
    typedef unsigned int        uint_fast16_t;
    typedef unsigned long       uint_fast32_t;
    typedef unsigned char       uint_least8_t;
    typedef unsigned int        uint_least16_t;
    typedef unsigned long       uint_least32_t;
    typedef uint32_t            uintmax_t;
		
		
		  typedef struct
    {
        volatile uint8_t    bit0    :1;
        volatile uint8_t    bit1    :1;
        volatile uint8_t    bit2    :1;
        volatile uint8_t    bit3    :1;
        volatile uint8_t    bit4    :1;
        volatile uint8_t    bit5    :1;
        volatile uint8_t    bit6    :1;
        volatile uint8_t    bit7    :1;
    } bits_t;
    
    
    #ifndef NULL
        #define NULL		((void*)0)
    #endif

#endif  // #ifndef STDINT_H