#ifndef STM8L_CLK_H
    #define STM8L_CLK_H


#include <stdint.h>


		
typedef  struct
{
	union
    {
       volatile uint8_t CLK_DIVR;
       //volatile bits_t  CLK_DIVRb;
			 volatile uint8_t CKM :3;
			 volatile uint8_t REZ_CKM:5;
    };
    union
    {
       volatile uint8_t CLK_CRTCR;
       volatile bits_t  CLK_CRTCRb;
    };	
    union
    {
        volatile uint8_t CLK_ICKR;
       volatile bits_t  CLK_ICKRb;
    };
  
		union
    {
       volatile uint8_t CLK_PCKENR1;
        //volatile bits_t  CLK_PCKENR1b;
			 volatile uint8_t CLK_Perif_TIM2 :1;
			 volatile uint8_t CLK_Perif_TIM3:1;
			 volatile uint8_t CLK_Perif_TIM4 :1;
			 volatile uint8_t CLK_Perif_I2C1 :1;
			 volatile uint8_t CLK_Perif_SPI1 :1;
			 volatile uint8_t CLK_Perif_USART1 :1;
			 volatile uint8_t CLK_Perif_BEEP :1;
			 volatile uint8_t CLK_Perif_DAC :1;
    };
		union
    {
       volatile uint8_t CLK_PCKENR2;
       volatile bits_t  CLK_PCKENR2b;
    };
		
    union
    {
       volatile uint8_t CLK_CCOR;
       volatile bits_t  CLK_CCORb;
    };
		
		union
    {
      volatile  uint8_t CLK_ECKR;
       volatile bits_t  CLK_ECKRb;
    };
		
		
    union
    {
       volatile uint8_t CLK_SCSR;
       volatile bits_t  CLK_SCSRb;
    };
   union
    {
       volatile uint8_t CLK_SWR;
       volatile bits_t  CLK_SWRb;
    };
		union
    {
       volatile uint8_t CLK_SWRD;
       volatile bits_t  CLK_SWRDb;
    };
		union
    {
       volatile uint8_t CLK_CSSR;
       volatile bits_t  CLK_CSSRb;
    };
		  union
    {
       volatile uint8_t CLK_CBEEPR;
       volatile bits_t  CLK_CBEEPRb;
    };
   union
    {
       volatile uint8_t CLK_HSICALR;
       volatile bits_t  CLK_HSICALRb;
    };
		union
    {
       volatile uint8_t CLK_HSITRIMR;
        volatile bits_t  CLK_HSITRIMRb;
    };
		union
    {
       volatile uint8_t CLK_HSIUNLCKR;
       volatile bits_t  CLK_HSIUNLCKRb;
    };
		union
    {
       volatile uint8_t CLK_REGCSP;
       volatile bits_t  CLK_REGCSPb;
    };
		
		
} CLK_t;



#define CLK  ((CLK_t*)0x50C0)

typedef enum {
  CLKDiv_1   = (uint8_t)0x00, /*!< System Clock Divider: 1 */
  CLKDiv_2   = (uint8_t)0x01, /*!< System Clock Divider: 2 */
  CLKDiv_4   = (uint8_t)0x02, /*!< System Clock Divider: 4 */
  CLKDiv_8   = (uint8_t)0x03, /*!< System Clock Divider: 8 */
  CLKDiv_16  = (uint8_t)0x04, /*!< System Clock Divider: 16 */
  CLKDiv_32  = (uint8_t)0x05, /*!< System Clock Divider: 32 */
  CLKDiv_64  = (uint8_t)0x06, /*!< System Clock Divider: 64 */
  CLKDiv_128 = (uint8_t)0x07  /*!< System Clock Divider: 128 */
} CLKDiv_TypeDef;

#endif  // #ifndef STM8L_CLK_H