/*
ver 0.1b  gpio.h
 -      / MCU  STM8S
    Cosmic
TODO -  ,  ,  ()   .
,    kison@mail.ru
//   -    - http://open-electronics.ru/forum
*/


/*     
@inline void GPIO_ConfigOutput(gpio_t *gpio, uint8_t pin, OutputSpeed_t speed, OutputType_t type);
	  -    GPIO,  GPIOA,GPIOB  ..
	  -   , 0-7.
	  -  .  LoSpeed  HiSpeed
	  -  .   OpenDrain -   
                                                PushPull -   .
    :
    GPIO_ConfigOutput(GPIOE,0,LoSpeed,OpenDrain);
*/


/*     
@inline void GPIO_ConfigInput(gpio_t *gpio, uint8_t pin, InputType_t type, InputIrq_t  irq)
      -    GPIO,  GPIOA,GPIOB  ..
      -   , 0-7
      -  ,     Pullup   - Floating
      - /   .   IrqOn  IrqOff
*/


/*  :
        - GPIOx_ODR  PORTx.  PORTA, GPIOB_ODR
       - GPIOx_IDR  PINx.  PINA, GPIOB_IDR
      - GPIOx_DDR  DDRx.  DDRA, GPIOB_DDR
        :
     - PORTA0, PORTB6, PIND4, DDRB6
      CR1  CR2     GPIO
     GPIOA->CR1 |= (1<<bit_num);
         GPIOx_ - GPIOB_CR1
     - GPIOA_CR1 = 0;
           CR1/CR2  - GPIOA->CR1_BITS.bit0 = 1;
*/

#ifndef STM8L_GPIO_H
    #define STM8L_GPIO_H

    #include <stdint.h>
    
    
    typedef enum
    {
        LoSpeed         = ((uint8_t)0x00),
        HiSpeed         = ((uint8_t)0x01) 
    } OutputSpeed_t;
    
    typedef enum
    {
        OpenDrain       = ((uint8_t)0x00),
        PushPull	    = ((uint8_t)0x01) 
    } OutputType_t;
    
    typedef enum
    {
        Floating        = ((uint8_t)0x00),
        Pullup          = ((uint8_t)0x01) 
    } InputType_t;
    
    typedef enum
    {
        IrqOn 		    = ((uint8_t)0x00),
        IrqOff  	    = ((uint8_t)0x01) 
    } InputIrq_t;
    
    
 //   typedef struct
 //   {
 //       volatile uint8_t    bit0    :1;
 //       volatile uint8_t    bit1    :1;
 //       volatile uint8_t    bit2    :1;
 //       volatile uint8_t    bit3    :1;
 //       volatile uint8_t    bit4    :1;
 //       volatile uint8_t    bit5    :1;
 //       volatile uint8_t    bit6    :1;
 //       volatile uint8_t    bit7    :1;
  //  } bits_t;
    
    typedef struct
    {
        union
            {
                volatile uint8_t    ODR;
                volatile bits_t     ODR_BITS;
            };
        union
            {
                volatile uint8_t    IDR;
                volatile bits_t     IDR_BITS;
            };
        union
            {
                volatile uint8_t    DDR;
                volatile bits_t     DDR_BITS;
            };
        union
            {
                volatile uint8_t    CR1;
                volatile bits_t     CR1_BITS;
            };
        union
            {
                volatile uint8_t    CR2;
                volatile bits_t     CR2_BITS;
            };
    } gpio_t;
    
    #define GPIOA	    ((gpio_t*)0x5000)
    #define	GPIOB	    ((gpio_t*)0x5005)
    #define	GPIOC	    ((gpio_t*)0x500A)
    #define	GPIOD	    ((gpio_t*)0x500F)
    #define	GPIOE	    ((gpio_t*)0x5014)
    #define	GPIOF	    ((gpio_t*)0x5019)
    #define	GPIOG	    ((gpio_t*)0x501E)
    #define	GPIOH	    ((gpio_t*)0x5023)
    #define	GPIOI	    ((gpio_t*)0x5028)
    
    #define GPIOA_CR1   (GPIOA->CR1)
    #define GPIOA_CR2   (GPIOA->CR2)

    #define GPIOB_CR1   (GPIOB->CR1)
    #define GPIOB_CR2   (GPIOB->CR2)

    #define GPIOC_CR1   (GPIOC->CR1)
    #define GPIOC_CR2   (GPIOC->CR2)

    #define GPIOD_CR1   (GPIOD->CR1)
    #define GPIOD_CR2   (GPIOD->CR2)
    
    #define GPIOE_CR1   (GPIOE->CR1)
    #define GPIOE_CR2   (GPIOE->CR2)

    #define GPIOF_CR1   (GPIOF->CR1)
    #define GPIOF_CR2   (GPIOF->CR2)
    
    #define GPIOG_CR1   (GPIOG->CR1)
    #define GPIOG_CR2   (GPIOG->CR2)    

    #define GPIOH_CR1   (GPIOH->CR1)
    #define GPIOH_CR2   (GPIOH->CR2)

    #define GPIOI_CR1   (GPIOI->CR1)
    #define GPIOI_CR2   (GPIOI->CR2)

    #define PORTA       (GPIOA->ODR)
    #define GPIOA_ODR   (GPIOA->ODR)
    #define PORTA0      (GPIOA->ODR_BITS.bit0)
    #define PORTA1      (GPIOA->ODR_BITS.bit1)
    #define PORTA2      (GPIOA->ODR_BITS.bit2)
    #define PORTA3      (GPIOA->ODR_BITS.bit3)
    #define PORTA4      (GPIOA->ODR_BITS.bit4)
    #define PORTA5      (GPIOA->ODR_BITS.bit5)
    #define PORTA6      (GPIOA->ODR_BITS.bit6)
    #define PORTA7      (GPIOA->ODR_BITS.bit7)
    
    #define PORTB       (GPIOB->ODR)
    #define GPIOB_ODR   (GPIOB->ODR)
    #define PORTB0      (GPIOB->ODR_BITS.bit0)
    #define PORTB1      (GPIOB->ODR_BITS.bit1)
    #define PORTB2      (GPIOB->ODR_BITS.bit2)
    #define PORTB3      (GPIOB->ODR_BITS.bit3)
    #define PORTB4      (GPIOB->ODR_BITS.bit4)
    #define PORTB5      (GPIOB->ODR_BITS.bit5)
    #define PORTB6      (GPIOB->ODR_BITS.bit6)
    #define PORTB7      (GPIOB->ODR_BITS.bit7)
    
    #define PORTC       (GPIOC->ODR)
    #define GPIOC_ODR   (GPIOC->ODR)
    #define PORTC0      (GPIOC->ODR_BITS.bit0)
    #define PORTC1      (GPIOC->ODR_BITS.bit1)
    #define PORTC2      (GPIOC->ODR_BITS.bit2)
    #define PORTC3      (GPIOC->ODR_BITS.bit3)
    #define PORTC4      (GPIOC->ODR_BITS.bit4)
    #define PORTC5      (GPIOC->ODR_BITS.bit5)
    #define PORTC6      (GPIOC->ODR_BITS.bit6)
    #define PORTC7      (GPIOC->ODR_BITS.bit7)
    
    #define PORTD       (GPIOD->ODR)
    #define GPIOD_ODR   (GPIOD->ODR)
    #define PORTD0      (GPIOD->ODR_BITS.bit0)
    #define PORTD1      (GPIOD->ODR_BITS.bit1)
    #define PORTD2      (GPIOD->ODR_BITS.bit2)
    #define PORTD3      (GPIOD->ODR_BITS.bit3)
    #define PORTD4      (GPIOD->ODR_BITS.bit4)
    #define PORTD5      (GPIOD->ODR_BITS.bit5)
    #define PORTD6      (GPIOD->ODR_BITS.bit6)
    #define PORTD7      (GPIOD->ODR_BITS.bit7)
    
    #define PORTE       (GPIOE->ODR)
    #define GPIOE_ODR   (GPIOE->ODR)
    #define PORTE0      (GPIOE->ODR_BITS.bit0)
    #define PORTE1      (GPIOE->ODR_BITS.bit1)
    #define PORTE2      (GPIOE->ODR_BITS.bit2)
    #define PORTE3      (GPIOE->ODR_BITS.bit3)
    #define PORTE4      (GPIOE->ODR_BITS.bit4)
    #define PORTE5      (GPIOE->ODR_BITS.bit5)
    #define PORTE6      (GPIOE->ODR_BITS.bit6)
    #define PORTE7      (GPIOE->ODR_BITS.bit7)
    
    #define PORTF       (GPIOF->ODR)
    #define GPIOF_ODR   (GPIOF->ODR)
    #define PORTF0      (GPIOF->ODR_BITS.bit0)
    #define PORTF1      (GPIOF->ODR_BITS.bit1)
    #define PORTF2      (GPIOF->ODR_BITS.bit2)
    #define PORTF3      (GPIOF->ODR_BITS.bit3)
    #define PORTF4      (GPIOF->ODR_BITS.bit4)
    #define PORTF5      (GPIOF->ODR_BITS.bit5)
    #define PORTF6      (GPIOF->ODR_BITS.bit6)
    #define PORTF7      (GPIOF->ODR_BITS.bit7)
    
    #define PORTG       (GPIOG->ODR)
    #define GPIOG_ODR   (GPIOG->ODR)
    #define PORTG0      (GPIOG->ODR_BITS.bit0)
    #define PORTG1      (GPIOG->ODR_BITS.bit1)
    #define PORTG2      (GPIOG->ODR_BITS.bit2)
    #define PORTG3      (GPIOG->ODR_BITS.bit3)
    #define PORTG4      (GPIOG->ODR_BITS.bit4)
    #define PORTG5      (GPIOG->ODR_BITS.bit5)
    #define PORTG6      (GPIOG->ODR_BITS.bit6)
    #define PORTG7      (GPIOG->ODR_BITS.bit7)
    
    #define PORTH       (GPIOH->ODR)
    #define GPIOH_ODR   (GPIOH->ODR)
    #define PORTH0      (GPIOH->ODR_BITS.bit0)
    #define PORTH1      (GPIOH->ODR_BITS.bit1)
    #define PORTH2      (GPIOH->ODR_BITS.bit2)
    #define PORTH3      (GPIOH->ODR_BITS.bit3)
    #define PORTH4      (GPIOH->ODR_BITS.bit4)
    #define PORTH5      (GPIOH->ODR_BITS.bit5)
    #define PORTH6      (GPIOH->ODR_BITS.bit6)
    #define PORTH7      (GPIOH->ODR_BITS.bit7)
    
    #define PORTI       (GPIOI->ODR)
    #define GPIOI_ODR   (GPIOI->ODR)
    #define PORTI0      (GPIOI->ODR_BITS.bit0)
    #define PORTI1      (GPIOI->ODR_BITS.bit1)
    #define PORTI2      (GPIOI->ODR_BITS.bit2)
    #define PORTI3      (GPIOI->ODR_BITS.bit3)
    #define PORTI4      (GPIOI->ODR_BITS.bit4)
    #define PORTI5      (GPIOI->ODR_BITS.bit5)
    #define PORTI6      (GPIOI->ODR_BITS.bit6)
    #define PORTI7      (GPIOI->ODR_BITS.bit7)
    
    
    
    
    #define PINA       (GPIOA->IDR)
    #define GPIOA_IDR  (GPIOA->IDR)
    #define PINA0      (GPIOA->IDR_BITS.bit0)
    #define PINA1      (GPIOA->IDR_BITS.bit1)
    #define PINA2      (GPIOA->IDR_BITS.bit2)
    #define PINA3      (GPIOA->IDR_BITS.bit3)
    #define PINA4      (GPIOA->IDR_BITS.bit4)
    #define PINA5      (GPIOA->IDR_BITS.bit5)
    #define PINA6      (GPIOA->IDR_BITS.bit6)
    #define PINA7      (GPIOA->IDR_BITS.bit7)
    
    #define PINB       (GPIOB->IDR)
    #define GPIOB_IDR  (GPIOB->IDR)
    #define PINB0      (GPIOB->IDR_BITS.bit0)
    #define PINB1      (GPIOB->IDR_BITS.bit1)
    #define PINB2      (GPIOB->IDR_BITS.bit2)
    #define PINB3      (GPIOB->IDR_BITS.bit3)
    #define PINB4      (GPIOB->IDR_BITS.bit4)
    #define PINB5      (GPIOB->IDR_BITS.bit5)
    #define PINB6      (GPIOB->IDR_BITS.bit6)
    #define PINB7      (GPIOB->IDR_BITS.bit7)
    
    #define PINC       (GPIOC->IDR)
    #define GPIOC_IDR  (GPIOC->IDR)
    #define PINC0      (GPIOC->IDR_BITS.bit0)
    #define PINC1      (GPIOC->IDR_BITS.bit1)
    #define PINC2      (GPIOC->IDR_BITS.bit2)
    #define PINC3      (GPIOC->IDR_BITS.bit3)
    #define PINC4      (GPIOC->IDR_BITS.bit4)
    #define PINC5      (GPIOC->IDR_BITS.bit5)
    #define PINC6      (GPIOC->IDR_BITS.bit6)
    #define PINC7      (GPIOC->IDR_BITS.bit7)
    
    #define PIND       (GPIOD->IDR)
    #define GPIOD_IDR  (GPIOD->IDR)
    #define PIND0      (GPIOD->IDR_BITS.bit0)
    #define PIND1      (GPIOD->IDR_BITS.bit1)
    #define PIND2      (GPIOD->IDR_BITS.bit2)
    #define PIND3      (GPIOD->IDR_BITS.bit3)
    #define PIND4      (GPIOD->IDR_BITS.bit4)
    #define PIND5      (GPIOD->IDR_BITS.bit5)
    #define PIND6      (GPIOD->IDR_BITS.bit6)
    #define PIND7      (GPIOD->IDR_BITS.bit7)
    
    #define PINE       (GPIOE->IDR)
    #define GPIOE_IDR  (GPIOE->IDR)
    #define PINE0      (GPIOE->IDR_BITS.bit0)
    #define PINE1      (GPIOE->IDR_BITS.bit1)
    #define PINE2      (GPIOE->IDR_BITS.bit2)
    #define PINE3      (GPIOE->IDR_BITS.bit3)
    #define PINE4      (GPIOE->IDR_BITS.bit4)
    #define PINE5      (GPIOE->IDR_BITS.bit5)
    #define PINE6      (GPIOE->IDR_BITS.bit6)
    #define PINE7      (GPIOE->IDR_BITS.bit7)
    
    #define PINF       (GPIOF->IDR)
    #define GPIOF_IDR  (GPIOF->IDR)
    #define PINF0      (GPIOF->IDR_BITS.bit0)
    #define PINF1      (GPIOF->IDR_BITS.bit1)
    #define PINF2      (GPIOF->IDR_BITS.bit2)
    #define PINF3      (GPIOF->IDR_BITS.bit3)
    #define PINF4      (GPIOF->IDR_BITS.bit4)
    #define PINF5      (GPIOF->IDR_BITS.bit5)
    #define PINF6      (GPIOF->IDR_BITS.bit6)
    #define PINF7      (GPIOF->IDR_BITS.bit7)
    
    #define PING       (GPIOG->IDR)
    #define GPIOG_IDR  (GPIOG->IDR)
    #define PING0      (GPIOG->IDR_BITS.bit0)
    #define PING1      (GPIOG->IDR_BITS.bit1)
    #define PING2      (GPIOG->IDR_BITS.bit2)
    #define PING3      (GPIOG->IDR_BITS.bit3)
    #define PING4      (GPIOG->IDR_BITS.bit4)
    #define PING5      (GPIOG->IDR_BITS.bit5)
    #define PING6      (GPIOG->IDR_BITS.bit6)
    #define PING7      (GPIOG->IDR_BITS.bit7)
    
    #define PINH       (GPIOH->IDR)
    #define GPIOH_IDR  (GPIOH->IDR)
    #define PINH0      (GPIOH->IDR_BITS.bit0)
    #define PINH1      (GPIOH->IDR_BITS.bit1)
    #define PINH2      (GPIOH->IDR_BITS.bit2)
    #define PINH3      (GPIOH->IDR_BITS.bit3)
    #define PINH4      (GPIOH->IDR_BITS.bit4)
    #define PINH5      (GPIOH->IDR_BITS.bit5)
    #define PINH6      (GPIOH->IDR_BITS.bit6)
    #define PINH7      (GPIOH->IDR_BITS.bit7)
    
    #define PINI       (GPIOI->IDR)
    #define GPIOI_IDR  (GPIOI->IDR)
    #define PINI0      (GPIOI->IDR_BITS.bit0)
    #define PINI1      (GPIOI->IDR_BITS.bit1)
    #define PINI2      (GPIOI->IDR_BITS.bit2)
    #define PINI3      (GPIOI->IDR_BITS.bit3)
    #define PINI4      (GPIOI->IDR_BITS.bit4)
    #define PINI5      (GPIOI->IDR_BITS.bit5)
    #define PINI6      (GPIOI->IDR_BITS.bit6)
    #define PINI7      (GPIOI->IDR_BITS.bit7)
    
    
    
    #define DDRA       (GPIOA->DDR)
    #define GPIOA_DDR  (GPIOA->DDR)
    #define DDRA0      (GPIOA->DDR_BITS.bit0)
    #define DDRA1      (GPIOA->DDR_BITS.bit1)
    #define DDRA2      (GPIOA->DDR_BITS.bit2)
    #define DDRA3      (GPIOA->DDR_BITS.bit3)
    #define DDRA4      (GPIOA->DDR_BITS.bit4)
    #define DDRA5      (GPIOA->DDR_BITS.bit5)
    #define DDRA6      (GPIOA->DDR_BITS.bit6)
    #define DDRA7      (GPIOA->DDR_BITS.bit7)
    
    #define DDRB       (GPIOB->DDR)
    #define GPIOB_DDR  (GPIOB->DDR)
    #define DDRB0      (GPIOB->DDR_BITS.bit0)
    #define DDRB1      (GPIOB->DDR_BITS.bit1)
    #define DDRB2      (GPIOB->DDR_BITS.bit2)
    #define DDRB3      (GPIOB->DDR_BITS.bit3)
    #define DDRB4      (GPIOB->DDR_BITS.bit4)
    #define DDRB5      (GPIOB->DDR_BITS.bit5)
    #define DDRB6      (GPIOB->DDR_BITS.bit6)
    #define DDRB7      (GPIOB->DDR_BITS.bit7)
    
    #define DDRC       (GPIOC->DDR)
    #define GPIOC_DDR  (GPIOC->DDR)
    #define DDRC0      (GPIOC->DDR_BITS.bit0)
    #define DDRC1      (GPIOC->DDR_BITS.bit1)
    #define DDRC2      (GPIOC->DDR_BITS.bit2)
    #define DDRC3      (GPIOC->DDR_BITS.bit3)
    #define DDRC4      (GPIOC->DDR_BITS.bit4)
    #define DDRC5      (GPIOC->DDR_BITS.bit5)
    #define DDRC6      (GPIOC->DDR_BITS.bit6)
    #define DDRC7      (GPIOC->DDR_BITS.bit7)
    
    #define DDRD       (GPIOD->DDR)
    #define GPIOD_DDR  (GPIOD->DDR)
    #define DDRD0      (GPIOD->DDR_BITS.bit0)
    #define DDRD1      (GPIOD->DDR_BITS.bit1)
    #define DDRD2      (GPIOD->DDR_BITS.bit2)
    #define DDRD3      (GPIOD->DDR_BITS.bit3)
    #define DDRD4      (GPIOD->DDR_BITS.bit4)
    #define DDRD5      (GPIOD->DDR_BITS.bit5)
    #define DDRD6      (GPIOD->DDR_BITS.bit6)
    #define DDRD7      (GPIOD->DDR_BITS.bit7)
    
    #define DDRE       (GPIOE->DDR)
    #define GPIOE_DDR  (GPIOE->DDR)
    #define DDRE0      (GPIOE->DDR_BITS.bit0)
    #define DDRE1      (GPIOE->DDR_BITS.bit1)
    #define DDRE2      (GPIOE->DDR_BITS.bit2)
    #define DDRE3      (GPIOE->DDR_BITS.bit3)
    #define DDRE4      (GPIOE->DDR_BITS.bit4)
    #define DDRE5      (GPIOE->DDR_BITS.bit5)
    #define DDRE6      (GPIOE->DDR_BITS.bit6)
    #define DDRE7      (GPIOE->DDR_BITS.bit7)
    
    #define DDRF       (GPIOF->DDR)
    #define GPIOF_DDR  (GPIOF->DDR)
    #define DDRF0      (GPIOF->DDR_BITS.bit0)
    #define DDRF1      (GPIOF->DDR_BITS.bit1)
    #define DDRF2      (GPIOF->DDR_BITS.bit2)
    #define DDRF3      (GPIOF->DDR_BITS.bit3)
    #define DDRF4      (GPIOF->DDR_BITS.bit4)
    #define DDRF5      (GPIOF->DDR_BITS.bit5)
    #define DDRF6      (GPIOF->DDR_BITS.bit6)
    #define DDRF7      (GPIOF->DDR_BITS.bit7)
    
    #define DDRG       (GPIOG->DDR)
    #define GPIOG_DDR  (GPIOG->DDR)
    #define DDRG0      (GPIOG->DDR_BITS.bit0)
    #define DDRG1      (GPIOG->DDR_BITS.bit1)
    #define DDRG2      (GPIOG->DDR_BITS.bit2)
    #define DDRG3      (GPIOG->DDR_BITS.bit3)
    #define DDRG4      (GPIOG->DDR_BITS.bit4)
    #define DDRG5      (GPIOG->DDR_BITS.bit5)
    #define DDRG6      (GPIOG->DDR_BITS.bit6)
    #define DDRG7      (GPIOG->DDR_BITS.bit7)
    
    #define DDRH       (GPIOH->DDR)
    #define GPIOH_DDR  (GPIOH->DDR)
    #define DDRH0      (GPIOH->DDR_BITS.bit0)
    #define DDRH1      (GPIOH->DDR_BITS.bit1)
    #define DDRH2      (GPIOH->DDR_BITS.bit2)
    #define DDRH3      (GPIOH->DDR_BITS.bit3)
    #define DDRH4      (GPIOH->DDR_BITS.bit4)
    #define DDRH5      (GPIOH->DDR_BITS.bit5)
    #define DDRH6      (GPIOH->DDR_BITS.bit6)
    #define DDRH7      (GPIOH->DDR_BITS.bit7)
    
    #define DDRI       (GPIOI->DDR)
    #define GPIOI_DDR  (GPIOI->DDR)
    #define DDRI0      (GPIOI->DDR_BITS.bit0)
    #define DDRI1      (GPIOI->DDR_BITS.bit1)
    #define DDRI2      (GPIOI->DDR_BITS.bit2)
    #define DDRI3      (GPIOI->DDR_BITS.bit3)
    #define DDRI4      (GPIOI->DDR_BITS.bit4)
    #define DDRI5      (GPIOI->DDR_BITS.bit5)
    #define DDRI6      (GPIOI->DDR_BITS.bit6)
    #define DDRI7      (GPIOI->DDR_BITS.bit7)
    
    
    
    
    @inline void GPIO_ConfigOutput(gpio_t *gpio, uint8_t pin, OutputSpeed_t speed, OutputType_t type)
    {
        gpio->DDR |= (uint8_t)(1<<(pin & 0x07));
        if(type == OpenDrain) gpio->CR1 &= (uint8_t)(~ (1<<(pin & 0x07)));
            else gpio->CR1 |= (uint8_t)(1<<(pin & 0x07));
    
        if(speed == LoSpeed) gpio->CR2 &= (uint8_t)(~(1<<(pin & 0x07)));
            else gpio->CR2 |= (uint8_t)(1<<(pin & 0x07));
            
    }
    
    @inline void GPIO_ConfigInput(gpio_t *gpio, uint8_t pin, InputType_t type, InputIrq_t  irq)
        {
            if(irq == InpIrqOff) gpio->CR2 &= (uint8_t)(~(1<<(pin & 0x07)));                
                else gpio->CR2 |= (uint8_t)(1<<(pin & 0x07));
    
            if(type == InpFloating) gpio->CR1 &= (uint8_t)(~(1<<(pin & 0x07)));    
                else gpio->CR1 |= (uint8_t)(1<<(pin & 0x07));
                
            gpio->DDR &= (uint8_t)(~(1<<(pin & 0x07)));   
        }

#endif  // #ifndef STM8L_GPIO_H