
#include <lcd.h>
#include <delay.h>
#include <font.h>


void Lcd_Init(void){
CS=1;
CS=0; 
RES=0; 
delay_ms(5);         // 5mS so says the stop watch(less than 5ms will not work) 
RES=1; 


    Lcd_Write ( CMD , 0x20 ); // write VOP register
    Lcd_Write ( CMD , 0x90 ); //set contrast
    Lcd_Write ( CMD , 0xA4 ); // all on/normal display
    Lcd_Write ( CMD , 0x2F ); // Power control set(charge pump on/off)
    Lcd_Write ( CMD , 0x40 ); // set start row address = 0
    Lcd_Write ( CMD , 0xb0 ); // set Y-address = 0
    Lcd_Write ( CMD , 0x10 ); // set X-address, upper 3 bits
    Lcd_Write ( CMD , 0x00 );  // set X-address, lower 4 bits
    Lcd_Write ( CMD , 0xC0 ); // mirror Y axis (about X axis) 
    Lcd_Write ( CMD , 0xa1 ); // Invert screen in horizontal axis 
    Lcd_Write ( CMD , 0xac ); // set initial row (R0) of the display
    Lcd_Write ( CMD , 0x07 );
   


delay_ms(10);
Lcd_Clear(); // clear LCD 
//Lcd_Write(CMD,0xa7); // invert display 
delay_ms(100);        
Lcd_Write(CMD,0xa6); // normal display (non inverted) 
    
} 


void Lcd_Write(char cd,unsigned char c)
{ 
int i; 
   CS=0; 
   SCLK=0; 
   SDA=cd;
	 SCLK=1; 
	 delay_us(1); 
   //SCLK=0; 


for(i=0;i<8;i++){ 
      SCLK=0; 
         if((c & 0x80)) 
            SDA=1; 
         else 
            SDA=0;
			delay_us(1); 			
      SCLK=1; 
      c <<= 1; 
     
            }
		SCLK=0;
		SDA=0;
     CS=1; 
      

 } 

void Lcd_Clear(void){ 
unsigned int i; 
Lcd_Write(CMD,0x40); // Y = 0 
Lcd_Write(CMD,0xb0); 
Lcd_Write(CMD,0x10); // X = 0 
Lcd_Write(CMD,0x0); 
Lcd_Write(CMD,0xae); // disable display; 
for(i=0;i<255;i++) 
Lcd_Write(DATA,0x00); 
for(i=0;i<255;i++) 
Lcd_Write(DATA,0x00); 
for(i=0;i<255;i++) 
Lcd_Write(DATA,0x00); 
for(i=0;i<99;i++) 
Lcd_Write(DATA,0x00); 
Lcd_Write(CMD,0xaf); // enable display; 
}  
 
void lcd_char(unsigned char c)
{
	
	
	unsigned char line;
	unsigned char ch;
  unsigned char * f;
	
  if(c < 32){
		c=' ';
		}  	
	if(c>=192)c-=96;
   else c-=32;

   f= &(Font5x8[c][0]);
 
	 
	for(line=0;line<5;line++)
	{
		ch = *f++;
		Lcd_Write(DATA,ch); 
	}
	Lcd_Write(DATA,0x00);	
}
 
 void lcd_string(const unsigned char *text)
 {
	 while(*text)
	 {
		 lcd_char(*text);
		 *text++;
	 }
 }
 
 void Gotoxy(char x,char y){ 
      Lcd_Write(CMD,(0xB0|(y&0x0F)));       // Y axis initialisation: 0100 yyyy          
      Lcd_Write(CMD,(0x00|(x&0x0F)));       // X axis initialisation: 0000 xxxx ( x3 x2 x1 x0) 
      Lcd_Write(CMD,(0x10|((x>>4)&0x07))); // X axis initialisation: 0010 0xxx  ( x6 x5 x4) 
} 
